using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.Serialization;

public class PlayerController : MonoBehaviour
{

    [SerializeField] private float characterMovementSpeed = 5f;
    [SerializeField] private List<GameObject> playerPrefabs;
    [SerializeField] private int playerStartCharacter;

    private GameObject player;
    
    private float timer;
    
    // Start is called before the first frame update
    void Start()
    {

        foreach (var playerSecondaryPrefab in playerPrefabs)
        {
            Instantiate(playerSecondaryPrefab);
        }

        player = playerPrefabs[playerStartCharacter].GameObject();

        player.transform.position = new Vector3(0, 0, 0);
    }

    // Update is called once per frame
    void Update()
    {

        var characterNumber = -1;

        if (Input.GetKeyDown(KeyCode.Alpha1)) characterNumber = 0;
        else if (Input.GetKeyDown(KeyCode.Alpha2)) characterNumber = 1;
        else if (Input.GetKeyDown(KeyCode.Alpha3)) characterNumber = 2;
        else if (Input.GetKeyDown(KeyCode.Alpha4)) characterNumber = 3;
        else if (Input.GetKeyDown(KeyCode.Alpha5)) characterNumber = 4;
        else if (Input.GetKeyDown(KeyCode.Alpha6)) characterNumber = 5;
        if (Input.GetKeyDown(KeyCode.LeftShift) && characterMovementSpeed == 5f) characterMovementSpeed *= 2;
        else if (Input.GetKeyDown(KeyCode.LeftShift) && characterMovementSpeed == 10f) characterMovementSpeed *= 2;
        else if (Input.GetKeyDown(KeyCode.LeftShift) && characterMovementSpeed == 20f) characterMovementSpeed /= 4;
        if (Input.GetKeyDown(KeyCode.F))
        {
            Wooh(player.transform);
        }
        if (-1 < characterNumber)
        {
            var pos = new Vector3(player.transform.position.x, player.transform.position.y);
            player.transform.position = new Vector3(10000, 10000, 0);
            player = playerPrefabs[characterNumber].GameObject();
            player.transform.position = pos;
        }
        
        Vector3 velocityVector = Vector3.zero;

        if (Input.GetKey(KeyCode.W)) velocityVector.y = 1;
        if (Input.GetKey(KeyCode.A)) velocityVector.x = -1;
        if (Input.GetKey(KeyCode.S)) velocityVector.y = -1;
        if (Input.GetKey(KeyCode.D)) velocityVector.x = 1;
        
        velocityVector.Normalize();
        
        player.transform.position += Time.deltaTime * characterMovementSpeed * velocityVector;

        if (velocityVector != Vector3.zero)
        {
            timer += Time.deltaTime;
        }
    }

    public Vector3 GetPlayerPosition()
    {
        return player.transform.position;
    }
    public void Wooh(Transform blub)
    {
        Transform parent = blub;
        foreach (Transform child in parent)
        {
            if (child.childCount > 0) Wooh(child);
         try
          {
             SpriteRenderer rend = child.GetComponent<SpriteRenderer>();
             rend.color = Random.ColorHSV();
          }
        catch
          {
            try 
            {
            UnityEngine.U2D.SpriteShapeRenderer rend = child.GetComponent<UnityEngine.U2D.SpriteShapeRenderer>();
            rend.color = Random.ColorHSV();
            }
            catch
            {
        
            }
        }
    }
}
}